// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from clpe_ros_msgs:msg/ClpeCameraInfo.idl
// generated code does not contain a copyright notice

#ifndef CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__STRUCT_HPP_
#define CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__clpe_ros_msgs__msg__ClpeCameraInfo __attribute__((deprecated))
#else
# define DEPRECATED__clpe_ros_msgs__msg__ClpeCameraInfo __declspec(deprecated)
#endif

namespace clpe_ros_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ClpeCameraInfo_
{
  using Type = ClpeCameraInfo_<ContainerAllocator>;

  explicit ClpeCameraInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->calibration_model = 0ul;
      this->fx = 0.0f;
      this->fy = 0.0f;
      this->cx = 0.0f;
      this->cy = 0.0f;
      this->k1 = 0.0f;
      this->k2 = 0.0f;
      this->k3 = 0.0f;
      this->k4 = 0.0f;
      this->rms = 0.0f;
      this->fov = 0.0f;
      this->calibration_temperature = 0.0f;
      this->p1 = 0.0f;
      this->p2 = 0.0f;
      this->production_date = "";
    }
  }

  explicit ClpeCameraInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : production_date(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->calibration_model = 0ul;
      this->fx = 0.0f;
      this->fy = 0.0f;
      this->cx = 0.0f;
      this->cy = 0.0f;
      this->k1 = 0.0f;
      this->k2 = 0.0f;
      this->k3 = 0.0f;
      this->k4 = 0.0f;
      this->rms = 0.0f;
      this->fov = 0.0f;
      this->calibration_temperature = 0.0f;
      this->p1 = 0.0f;
      this->p2 = 0.0f;
      this->production_date = "";
    }
  }

  // field types and members
  using _calibration_model_type =
    uint32_t;
  _calibration_model_type calibration_model;
  using _fx_type =
    float;
  _fx_type fx;
  using _fy_type =
    float;
  _fy_type fy;
  using _cx_type =
    float;
  _cx_type cx;
  using _cy_type =
    float;
  _cy_type cy;
  using _k1_type =
    float;
  _k1_type k1;
  using _k2_type =
    float;
  _k2_type k2;
  using _k3_type =
    float;
  _k3_type k3;
  using _k4_type =
    float;
  _k4_type k4;
  using _rms_type =
    float;
  _rms_type rms;
  using _fov_type =
    float;
  _fov_type fov;
  using _calibration_temperature_type =
    float;
  _calibration_temperature_type calibration_temperature;
  using _p1_type =
    float;
  _p1_type p1;
  using _p2_type =
    float;
  _p2_type p2;
  using _production_date_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _production_date_type production_date;

  // setters for named parameter idiom
  Type & set__calibration_model(
    const uint32_t & _arg)
  {
    this->calibration_model = _arg;
    return *this;
  }
  Type & set__fx(
    const float & _arg)
  {
    this->fx = _arg;
    return *this;
  }
  Type & set__fy(
    const float & _arg)
  {
    this->fy = _arg;
    return *this;
  }
  Type & set__cx(
    const float & _arg)
  {
    this->cx = _arg;
    return *this;
  }
  Type & set__cy(
    const float & _arg)
  {
    this->cy = _arg;
    return *this;
  }
  Type & set__k1(
    const float & _arg)
  {
    this->k1 = _arg;
    return *this;
  }
  Type & set__k2(
    const float & _arg)
  {
    this->k2 = _arg;
    return *this;
  }
  Type & set__k3(
    const float & _arg)
  {
    this->k3 = _arg;
    return *this;
  }
  Type & set__k4(
    const float & _arg)
  {
    this->k4 = _arg;
    return *this;
  }
  Type & set__rms(
    const float & _arg)
  {
    this->rms = _arg;
    return *this;
  }
  Type & set__fov(
    const float & _arg)
  {
    this->fov = _arg;
    return *this;
  }
  Type & set__calibration_temperature(
    const float & _arg)
  {
    this->calibration_temperature = _arg;
    return *this;
  }
  Type & set__p1(
    const float & _arg)
  {
    this->p1 = _arg;
    return *this;
  }
  Type & set__p2(
    const float & _arg)
  {
    this->p2 = _arg;
    return *this;
  }
  Type & set__production_date(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->production_date = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__clpe_ros_msgs__msg__ClpeCameraInfo
    std::shared_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__clpe_ros_msgs__msg__ClpeCameraInfo
    std::shared_ptr<clpe_ros_msgs::msg::ClpeCameraInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ClpeCameraInfo_ & other) const
  {
    if (this->calibration_model != other.calibration_model) {
      return false;
    }
    if (this->fx != other.fx) {
      return false;
    }
    if (this->fy != other.fy) {
      return false;
    }
    if (this->cx != other.cx) {
      return false;
    }
    if (this->cy != other.cy) {
      return false;
    }
    if (this->k1 != other.k1) {
      return false;
    }
    if (this->k2 != other.k2) {
      return false;
    }
    if (this->k3 != other.k3) {
      return false;
    }
    if (this->k4 != other.k4) {
      return false;
    }
    if (this->rms != other.rms) {
      return false;
    }
    if (this->fov != other.fov) {
      return false;
    }
    if (this->calibration_temperature != other.calibration_temperature) {
      return false;
    }
    if (this->p1 != other.p1) {
      return false;
    }
    if (this->p2 != other.p2) {
      return false;
    }
    if (this->production_date != other.production_date) {
      return false;
    }
    return true;
  }
  bool operator!=(const ClpeCameraInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ClpeCameraInfo_

// alias to use template instance with default allocator
using ClpeCameraInfo =
  clpe_ros_msgs::msg::ClpeCameraInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace clpe_ros_msgs

#endif  // CLPE_ROS_MSGS__MSG__DETAIL__CLPE_CAMERA_INFO__STRUCT_HPP_
